      subroutine muladd_o_o(j,i,ltp1)
      integer(1) ltp1
      if (j<i) then
         ltp1=1
      elseif (i==j) then
         ltp1=3
      else
         ltp1=2
      endif
      return
      end
       subroutine muladd_o_oo(k,j,i,ltp1)
      integer(1) ltp1
      if(i<j) then
         if(k<i) then
            ltp1=1
         else if(k==i) then
            ltp1=5
         else if(k<j) then
            ltp1=3
         else if(k==j) then
            ltp1=6
         else
            ltp1=2
         endif
      else if(i>j) then
         if(k<j) then
            ltp1=1
         else if(k==j) then
            ltp1=7
         else if(k<i) then
            ltp1=4
         else if(k==i) then
            ltp1=8
         else
            ltp1=2
         endif
      else
         if(k<j) then
            ltp1=1
         else if(k==j) then
            ltp1=9
         else
            ltp1=2
         endif
      endif
      return
      end
       subroutine muladd_v_vv(d,b,a,ltp1)
      integer(1) ltp1
      integer a,b,d
      if(a<b) then
         if(d<a) then
            ltp1=2
         else if(d==a) then
            ltp1=5
         else if(d<b) then
            ltp1=3
         else if(d==b) then
            ltp1=6
         else
            ltp1=1
         endif
      else if(a>b) then
         if(d<b) then
            ltp1=2
         else if(d==b) then
            ltp1=7
         else if(d<a) then
            ltp1=4
         else if(d==a) then
            ltp1=8
         else
            ltp1=1
         endif
      else
         if(d<b) then
            ltp1=2
         else if(d==b) then
            ltp1=9
         else
            ltp1=1
         endif
      endif
      return
      end
